# Get an image from NAO. Display it and save it using PIL.

import sys
import time
import config
from naoqi import ALProxy


def sayHi(IP, PORT,s):
	motionProxy = config.loadProxy("ALMotion")
	postureProxy = config.loadProxy("ALRobotPosture")
	postureProxy.goToPosture("Stand", 1.0)
	ttsProxy=config.loadProxy("ALTextToSpeech")
	#ttsProxy.say(s)
	rad=0.0174532925
	names = ["RShoulderPitch", "RShoulderRoll","RElbowYaw","RElbowRoll","RWristYaw"]
	angles = [60*rad, -10*rad,60.8*rad,0.5*rad,104.5*rad]
	fractionMaxSpeed = 0.1
	motionProxy.setAngles(names, angles, fractionMaxSpeed)
	handName = 'RHand'
	motionProxy.openHand(handName)
	ttsProxy.say("place")
	time.sleep(3)
	ttsProxy.say("closing")
	motionProxy.closeHand(handName)
	#ttsProxy.say("move away")
	time.sleep(1.5)

#rsp-> RShoulderPitch, rsr-> RShoulderRoll, rey-> RElbowYaw
def initialPos(IP, PORT, rsp, rsr, rey,angle):
	motionProxy = config.loadProxy("ALMotion")
	postureProxy = config.loadProxy("ALRobotPosture")
	rad=0.0174532925
	names = ["RShoulderPitch", "RShoulderRoll","RElbowYaw","HeadYaw", "HeadPitch"]
	angles = [rsp*rad, rsr*rad, rey*rad, angle, 0]
	#if case == 1:
	#	angles = [119*rad, 0*rad,60.8*rad]
	#elif case == 2:
	#	angles = [119*rad, -10*rad,50.8*rad]
	#elif case == 3:
	#	angles = [119*rad, -20*rad,40.8*rad]
	#elif case == 4:
	#	angles = [119*rad, -20*rad,30.8*rad]
	#elif case == 5:
	#	angles = [119*rad, -30*rad,20.8*rad]
	#elif case == 6:
	#	angles = [119*rad, -10*rad,80.8*rad]

	fractionMaxSpeed = 0.1
	motionProxy.setAngles(names, angles, fractionMaxSpeed)
	time.sleep(2)
	

#rsp-> RShoulderPitch, rsr-> RShoulderRoll, rey-> RElbowYaw, fms-> fractionMaxSpeed, st-> sleepTime
def throwAction(IP, PORT, crsp, crsr, crey, fms=0.7, st=0.5):
	motionProxy = config.loadProxy("ALMotion")
	postureProxy = config.loadProxy("ALRobotPosture")
	rad=0.0174532925
	mP2 = config.loadProxy("ALMotion")
	handName = 'RHand'
	names = ["RShoulderPitch", "RShoulderRoll","RElbowYaw"]
	
	changes = [crsp*rad,crsr*rad,crey*rad]
	fractionMaxSpeed = fms
	sleepTime = st

	visionToolboxProxy = ALProxy("ALVisionToolbox", IP, PORT)
	# This records a 320*240 MJPG video at 10 fps.
    	# Note MJPG can't be recorded with a framerate lower than 3 fps.
    	fps=10
    	visionToolboxProxy.post.startVideoRecord_adv("ball.avi", 15, "MJPG", 1, -1)
	time.sleep(2)
	mP2.post.openHand(handName)
	time.sleep(sleepTime)
	motionProxy.post.changeAngles(names, changes, fractionMaxSpeed)
	time.sleep(3)
	# Video file is saved on the robot in the
	# /home/nao/naoqi/share/naoqi/vision/ folder.
	videoInfo = visionToolboxProxy.stopVideoRecord()
	postureProxy.goToPosture("Crouch", 1.0)

if __name__ == '__main__':
	IP = "172.27.22.102"  # Replace here with your NaoQi's IP address.
	PORT = 9559

	# Read IP address from first argument if any.
	if len(sys.argv) > 1:
		IP = sys.argv[1]


	s="hello" #"Hello place ball in my hand"

	motionProxy = config.loadProxy("ALMotion")
	postureProxy = config.loadProxy("ALRobotPosture")

	# Set NAO in stiffness On
	config.StiffnessOn(motionProxy)

	sayHi(IP, PORT, s)

#case 1 = 14deg
#case 2 = 7deg
#case 3 = 0deg
#case 4 = -7deg
#case 5 = -14deg

	initialPos(IP, PORT, 1)
	time.sleep(2)
	throwAction(IP, PORT, 1)
	time.sleep(2)
	# Set NAO in stiffness Off
	#postureProxy.goToPosture("Crouch", 1.0)
	config.StiffnessOff(motionProxy)

