# Get an image from NAO. Display it and save it using PIL.

import sys
import time

# Python Image Library
import Image
import config
import cv
#import vision_definations
from naoqi import ALProxy


def showNaoImage(IP, PORT,camera_id):
  print "hello"
  """
  First get an image from Nao, then show it on the screen with PIL.
  """
  # Select the lower camera
  camProxy = config.loadProxy("ALVideoDevice")
  camProxy.kCameraSelectID=18
  print camProxy.getParam(camProxy.kCameraSelectID)
  camProxy.setParam(camProxy.kCameraSelectID,camera_id)
#  print camProxy.getParam(camProxy.kCameraSelectID)
  
  resolution =  1   # VGA
  colorSpace = 11   # RGB

  videoClient = camProxy.subscribe("python_client", resolution, colorSpace, 5)

  t0f = time.time()
  naoVideo = []
  for i in range(30):
  	t0 = time.time()

  	# Get a camera image.
  	# image[6] contains the image data passed as an array of ASCII chars.
  	naoImage = camProxy.getImageRemote(videoClient)
	naoVideo.append(naoImage)
  	t1 = time.time()

  	# Time the image transfer.
  	print "acquisition delay ",i," = " , t1 - t0

  t1f = time.time()
  print "total time = ", t1f-t0f

  camProxy.unsubscribe(videoClient)


  # Now we work with the image returned and save it as a PNG  using ImageDraw
  # package.

  # Get the image size and pixel array.
  for i in range(30):
  	imageWidth = naoVideo[i][0]
  	imageHeight = naoVideo[i][1]
  	array = naoVideo[i][6]

  	# Create a PIL Image from our pixel array.
  	im = Image.fromstring("RGB", (imageWidth, imageHeight), array)

  	# Save the image.
  	im.save("ball/camImage"+str(i)+".png", "PNG")
  	#im.show()

if __name__ == '__main__':
  IP = "172.27.22.102"  # Replace here with your NaoQi's IP address.
  PORT = 9559

  # Read IP address from first argument if any.
  if len(sys.argv) > 1:
    IP = sys.argv[1]

  showNaoImage(IP, PORT, 0)


