# Get an image from NAO. Display it and save it using PIL.

import sys
import time
import threading
import config
from naoqi import ALProxy


def closeHand():
	# print "Front:", mem.getData('FrontTactilTouched')
	#if mem.getData('FrontTactilTouched') > 0.5:
	motionProxy.closeHand("RHand")
	threading.Timer(0.01, closeHand).start()

def openHand():
	# print "Front:", mem.getData('FrontTactilTouched')
	#if mem.getData('RearTactilTouched') > 0.5:
	motionProxy.openHand("RHand")
	threading.Timer(0.01, openHand).start()

def sayHi(IP, PORT,s):
	ttsProxy=config.loadProxy("ALTextToSpeech")
	ttsProxy.say(s)
	rad=0.0174532925
	names = ["RShoulderPitch", "RShoulderRoll","RElbowYaw","RElbowRoll","RWristYaw"]
	angles = [60*rad, -10*rad,60.8*rad,0.5*rad,104.5*rad]
	fractionMaxSpeed = 0.2
	motionProxy.setAngles(names, angles, fractionMaxSpeed)
	handName = 'RHand'
	motionProxy.openHand(handName)
	time.sleep(1.5)
	motionProxy.closeHand(handName)

def initialPos(IP, PORT):
	rad=0.0174532925
	names = ["RShoulderPitch", "RShoulderRoll","RElbowYaw","RElbowRoll","RWristYaw"]
	angles = [119*rad, -40*rad,60.8*rad,0.5*rad,104.5*rad]
	fractionMaxSpeed = 0.2
	motionProxy.setAngles(names, angles, fractionMaxSpeed)
	time.sleep(0.5)
	

def grabBall(IP, PORT):
	handName = 'RHand'
	#motionProxy.openHand(handName)

def throwAction(IP, PORT):
	rad=0.0174532925
	#motionProxy = ALProxy("ALMotion")
	names = ["RShoulderPitch", "RShoulderRoll"]
	#angleLists = [[30*rad],[-5*rad]]
	#times = [[1.3], [1.3]]
	#isAbsolute = True
	#motionProxy.angleInterpolation(names, angleLists, times, isAbsolute)
	#targetAngles = [30*rad,-5*rad]
	#maxSpeedFraction = 0.2f
	#motionProxy.angleInterpolationWithSpeed(names, targetAngles, maxSpeedFraction)
	changes = [-80*rad,40*rad]
	fractionMaxSpeed = .3
	motionProxy.changeAngles(names, changes, fractionMaxSpeed)
	time.sleep(0.005)
	handName = 'RHand'
	motionProxy.openHand(handName)
	

if __name__ == '__main__':
	IP = "172.27.22.102"  # Replace here with your NaoQi's IP address.
	PORT = 9559

	# Read IP address from first argument if any.
	if len(sys.argv) > 1:
		IP = sys.argv[1]


	s="Hello place ball in my hand"

	motionProxy = config.loadProxy("ALMotion")
	mem = config.loadProxy('ALMemory')

	sayHi(IP, PORT, s)
	# Set NAO in stiffness On
	config.StiffnessOn(motionProxy)

	initialPos(IP, PORT)

	time.sleep(2)

	throwAction(IP, PORT)

	config.StiffnessOff(motionProxy)

