import sys
import cv2
import cv
import Image
import numpy as np
import math
from matplotlib import pyplot as plt

def findgoal(image):
	img = cv2.imread(image,1)
	imgWidth = img.shape[1]
	imgHeight = img.shape[0]
	#print "Width of the image :" + str(img.shape[1]) #width
	#print "Height of the image :" + str(img.shape[0]) #hight
	
	hsv = cv2.cvtColor(img,cv2.COLOR_BGR2HSV)
	#print hsv[50][300]
	#plt.imshow(img, cmap = 'gray', interpolation = 'bicubic')
	#plt.show()
	#cv2.imshow("HSV Image", hsv)
	
	#ORANGE_MIN = np.array([0, 0, 0],np.uint8)
	#ORANGE_MAX = np.array([100, 255, 255],np.uint8)
	#yellow = cv2.inRange(hsv, ORANGE_MIN, ORANGE_MAX)

	yellow = cv2.inRange(hsv,np.array((0,100,80),np.uint8),np.array((180,255,255),np.uint8))
	#cv2.imshow("Binary Image", yellow)

	erode = cv2.erode(yellow,None,iterations = 2)
	#cv2.imshow("erode Image", erode)
	
	dilate = cv2.dilate(erode,None,iterations = 3)
	#cv2.imshow("dilate Image", dilate)
	#cv2.waitKey(0);
	contours,hierarchy = cv2.findContours(dilate,cv2.RETR_LIST,cv2.CHAIN_APPROX_SIMPLE)
	
	#print "Y-axis : Top to bottom"
	#print "X-axis : Left to right"
	
	Cx,Cy,W,H,X,Y=0,0,0,0,0,0
	
	maxdiag=0
	
	for cnt in contours:
	    x,y,w,h = cv2.boundingRect(cnt)
	    cx,cy = x+w/2, y+h/2
	    cv2.rectangle(img,(x,y),(x+w,y+h),[0,255,255],2)
	
	    if (math.sqrt(w*w+h*h)>maxdiag) :
			maxdiag=math.sqrt(w*w+h*h)
			Cx,Cy,W,H,X,Y=cx,cy,w,h,x,y
		
	
	    
	cv2.rectangle(img,(X,Y),(X+W,Y+H),[0,23,255],2)
        
	#print "CENTER : ("+ str(Cx)+","+str(Cy)+") , WIDTH :"+str(W)+", HEIGHT :"+str(H)
 
	H_real = 3.5;
	W_real = 3.5;
	yratio = 0.4435483870967742 #for headpitch=0, 80cm is shown as 240-65 px
	if W<10 or W>100:
		return Cx, Cy, 0, 0, W, H
	Real_X = (Cx - imgWidth/2)*W_real/W
	Real_Y = (imgHeight-Cy)*yratio	
	print imgHeight-Cy

	print "X in NAO Frame = "+str(Real_X)
	print "Y in NAO Frame = "+str(Real_Y)
	theta = math.atan(Real_X/Real_Y)
	
	#print "X in NAO Frame = "+str(Real_X)
	#print "Y in NAO Frame = "+str(Real_Y)
	cv2.imshow('goal detected Image',img)
	
	cv2.waitKey(0)
	return Cx, Cy, Real_X, Real_Y, W, H




