import sys
import os
import config
import time
import vision_getandsaveimage as vg
import PPtake_position as tp
import PP_2dirThrow as dth
import aviToImg as atm

def linearize(x2,x1,x,y1,y2):
	y = (x*(y2-y1)+x2*y1-x1*y2)/(x2-x1)
	return y

IP = config.IP
PORT = config.PORT

initialAngleHeadRotate = int(sys.argv[1])
#capture image
rad=0.0174532925
postureProxy = config.loadProxy("ALRobotPosture")
postureProxy.goToPosture("Stand", 1.0)
vg.showNaoImage(IP,PORT,1,-initialAngleHeadRotate*rad)

#process image to get angle from nao
theta = tp.take_position()+initialAngleHeadRotate

#postureProxy.goToPosture("Crouch", 1.0)
#motionProxy = config.loadProxy("ALMotion")
#config.StiffnessOff(motionProxy)
#loading modules

motionProxy = config.loadProxy("ALMotion")
postureProxy = config.loadProxy("ALRobotPosture")

#calculating case to run depending on Theta

#case 1 = 14deg
#case 2 = 7deg
#case 3 = 0deg
#case 4 = -7deg
#case 5 = -14deg

##
mypath = "PP_throwCase.txt"
fin = open(mypath,'r').readlines()[1:]

cases=[]
for l in fin:
	l.strip()
	cases.append(l.split(','))

t1 = -100
print cases
for i in range(len(cases)):
	if float(cases[i][0]) >= theta:
		if i+1 < len(cases):
			if float(cases[i+1][0]) <= theta:
				t1 = i
		else:
			print "-----> Out Of Range <-----"

theta1 = rsp1 = rsr1 = rey1 = crsp1 = crsr1 = crey1 = fms1 = st1 = ''
theta2 = rsp2 = rsr2 = rey2 = crsp2 = crsr2 = crey2 = fms2 = st2 = ''
if t1!=-100:
	theta1, rsp1, rsr1, rey1, crsp1, crsr1, crey1, fms1, st1 = cases[t1][0:]
	theta2, rsp2, rsr2, rey2, crsp2, crsr2, crey2, fms2, st2 = cases[t1+1][0:]

print "theta1=",theta1,"rsp1-> ",rsp1, " rsr1-> ",rsr1," rey1-> ", rey1," crsp1-> ", crsp1," crsr1-> ", crsr1," crey1-> ", crey1," fms1-> ", fms1," st1-> ", st1
print "theta=",theta2,"rsp2-> ",rsp2, " rsr2-> ",rsr2," rey2-> ", rey2," crsp2-> ", crsp2," crsr2-> ", crsr2," crey2-> ", crey2," fms2-> ", fms2," st2-> ", st2

theta = float(theta)
rsp = linearize(float(theta2),float(theta1),float(theta),float(rsp1),float(rsp2))
rsr = linearize(float(theta2),float(theta1),float(theta),float(rsr1),float(rsr2))
rey = linearize(float(theta2),float(theta1),float(theta),float(rey1),float(rey2))
crsp = linearize(float(theta2),float(theta1),float(theta),float(crsp1),float(crsp2))
crsr = linearize(float(theta2),float(theta1),float(theta),float(crsr1),float(crsr2))
crey = linearize(float(theta2),float(theta1),float(theta),float(crey1),float(crey2))
fms = linearize(float(theta2),float(theta1),float(theta),float(fms1),float(fms2))
st = linearize(float(theta2),float(theta1),float(theta),float(st1),float(st2))

print -initialAngleHeadRotate*rad

false=1
while false:
	print "theta=",str(theta),"rsp-> ",str(rsp), " rsr-> ",str(rsr)," rey-> ", str(rey)," crsp-> ", str(crsp)," crsr-> ", str(crsr)," crey-> ", str(crey)," fms-> ", str(fms)," st-> ", str(st)

	# Set NAO in stiffness On
	config.StiffnessOn(motionProxy)

	#praparing nao to hold the ball
	s="hello"
	dth.sayHi(IP, PORT, s)

	dth.initialPos(IP, PORT, rsp, rsr, rey,-initialAngleHeadRotate*rad)
	time.sleep(2)
	dth.throwAction(IP, PORT, crsp, crsr, crey, fms, st)
	time.sleep(2)
	config.StiffnessOff(motionProxy)
	os.system("bash PP_naoServer.sh")
	#feedback
	#sftp command to get video from nao server
	ftheta = atm.GetBall()
	print "feedback = ", str(ftheta)
	if ftheta >= theta-5 and ftheta <= theta+5:
		false = 0
	else:
		print "feedback required"
		false = 0
