# Get an image from NAO. Display it and save it using PIL.

import sys
import time

# Python Image Library
import Image
import config
import cv
#import vision_definations
from naoqi import ALProxy

def recordVideo(IP, PORT):
	camProxy = config.loadProxy("ALVideoDevice")
	camProxy.kCameraSelectID=18
	print camProxy.getParam(camProxy.kCameraSelectID)
	camProxy.setParam(camProxy.kCameraSelectID,0)
#  print camProxy.getParam(camProxy.kCameraSelectID)

  
  
	resolution =  1   # VGA
	colorSpace = 11   # RGB
	success = camProxy.recordVideo("monitor", "/home/pratibha/Downloads/cs365/project/code/myfile", 100, 2)
# This will record 100 images in myFile.arv at half the framerate of Monitor.
	print "="*10,success
# Stop grabbing
	#camProxy.stopVideo()

def replay(IP, PORT):
	camProxy = ALProxy("ALVideoDevice", IP, PORT)
	pRange = [20, 80]
	pLoop = True
	pReplayMode = 3
	pStreamNumber = 0 #optional
	camProxy.setVideo("/home/nao/naoqi/data/myFile.arv", pRange, pLoop, pReplayMode, pStreamNumber)
	# You can now launch Monitor that will display the 21st frame of the file
	
	# Provide the 22nd image to the VIM that will transmit it to the GVM
	camProxy.nextImage()

# Plays a new frame every 2 seconds. NextImage() and previousImage() can still be called.
	camProxy.replaySpeed(0.5)


def showNaoImage(IP, PORT,camera_id):
  """
  First get an image from Nao, then show it on the screen with PIL.
  """
  # Select the lower camera
  camProxy = config.loadProxy("ALVideoDevice")
  camProxy.kCameraSelectID=18
  print camProxy.getParam(camProxy.kCameraSelectID)
  camProxy.setParam(camProxy.kCameraSelectID,camera_id)
#  print camProxy.getParam(camProxy.kCameraSelectID)

  
  
  resolution =  1   # VGA
  colorSpace = 11   # RGB
  t0 = time.time()
  videoClient = camProxy.subscribe("python_client", resolution, colorSpace, 5)
  for i in range(0,100):
    

    

  # Get a camera image.
  # image[6] contains the image data passed as an array of ASCII chars.
    naoImage = camProxy.getImageRemote(videoClient)

    
    


  # Now we work with the image returned and save it as a PNG  using ImageDraw
  # package.

  # Get the image size and pixel array.
    imageWidth = naoImage[0]
    imageHeight = naoImage[1]
    array = naoImage[6]

  # Create a PIL Image from our pixel array.
    im = Image.fromstring("RGB", (imageWidth, imageHeight), array)

  # Save the image.
    if i==0:
      im.save("camImage.png", "PNG")
    else:
      im.save("camImage.png"+str(i), "PNG")
  camProxy.unsubscribe(videoClient)
  t1 = time.time()

  # Time the image transfer.
  print "acquisition delay ", t1 - t0

  im.show()



if __name__ == '__main__':
  #IP = "169.254.232.52"  # Replace here with your NaoQi's IP address.
  IP ="172.27.22.77"
  PORT = 9559

  # Read IP address from first argument if any.
  if len(sys.argv) > 1:
    IP = sys.argv[1]
  recordVideo(IP, PORT)
  #replay(IP, PORT)
  #showNaoImage(IP, PORT, 0)


